"""Code generated by __main__"""

from dataclasses import dataclass, field
from typing import List

from sigtech.api.data.utils import BaseRule


@dataclass
class StaleValueRule(BaseRule):
    """
    For the selected columns, raise an issue for blocks of rows where the column value doesn't change.

    :param columns (List[str]): Select at least one column:
        - minItems: 1
        - uniqueItems: True
    :param stale_periods (int): Raise an issue for stale periods of:
        - min: 0

    docs: https://sigtech.gitbook.io/dave/rules#stale
    """  # noqa: E501

    columns: List[str] = field(
        metadata={
            "description": "Select at least one column:",
            "minItems": 1,
            "uniqueItems": True,
            "type": "List[str]",
        }
    )

    stale_periods: int = field(
        metadata={
            "description": "Raise an issue for stale periods of:",
            "min": 0,
            "type": "int",
        }
    )
