"""Code generated by __main__"""

from dataclasses import dataclass, field
from typing import List, Union

from sigtech.api.data.utils import BaseRule


@dataclass
class ValueInRangeRule(BaseRule):
    """
    For the selected columns, raise an issue if the value is outside the maximum or minimum.

    :param columns (List[str]): Select at least one column:
        - minItems: 1
        - uniqueItems: True
    :param min (Union[float, str]): Raise an issue for values less than:
        - anyOf: [{'type': 'number'}, {'type': 'string'}]
    :param max (Union[float, str]): Raise an issue for values greater than:
        - anyOf: [{'type': 'number'}, {'type': 'string'}]

    docs: https://sigtech.gitbook.io/dave/rules#range
    """  # noqa: E501

    columns: List[str] = field(
        metadata={
            "description": "Select at least one column:",
            "minItems": 1,
            "uniqueItems": True,
            "type": "List[str]",
        }
    )

    min: Union[float, str] = field(
        metadata={
            "description": "Raise an issue for values less than:",
            "anyOf": [{"type": "number"}, {"type": "string"}],
            "type": "Union[float, str]",
        }
    )

    max: Union[float, str] = field(
        metadata={
            "description": "Raise an issue for values greater than:",
            "anyOf": [{"type": "number"}, {"type": "string"}],
            "type": "Union[float, str]",
        }
    )
