"""Code generated by __main__"""

from dataclasses import dataclass, field
from typing import List

from sigtech.api.data.utils import BaseRule


@dataclass
class ZScoreRule(BaseRule):
    """
    For the selected columns, raise an issue where a value has a Z-score greater than the set limit.

    :param columns (List[str]): Select at least one column:
        - minItems: 1
        - uniqueItems: True
    :param z_score_tolerance (float): Raise an issue for Z-scores higher than
        - default: 1.0
        - min: 0.0
    :param window_size (int):
        - min: 0
    :param on_returns_enum (str):
        - default: 'Use raw values'

    docs: https://sigtech.gitbook.io/dave/rules#zscore
    """  # noqa: E501

    columns: List[str] = field(
        metadata={
            "description": "Select at least one column:",
            "minItems": 1,
            "uniqueItems": True,
            "type": "List[str]",
        }
    )

    window_size: int = field(metadata={"min": 0, "type": "int"})

    z_score_tolerance: float = field(
        default=1.0,
        metadata={
            "description": "Raise an issue for Z-scores higher than",
            "default": 1.0,
            "min": 0.0,
            "type": "float",
        },
    )

    on_returns_enum: str = field(
        default="Use raw values",
        metadata={"default": "'Use raw values'", "type": "str"},
    )
